/* 
	csw-imagetextblock.js
   	
	Version: [2018-01-02 01:28 pm]
*/

jQuery(document).ready(function(){

	jQuery('.cswImageTextblock.cswLayout-2x2ImageCenter .cswOverlayWrapper').each( function(){
		bRet = setOrigColorInDataAttr( this );
		
		if( bRet )
		{
			// register a mouseenter event
			jQuery(this).mouseenter( function() {
		      csw2x2ToggleColors( this, 'enter' );		
			});
		   
		   // register a mouseleave event
			jQuery(this).mouseleave( function() {
		      csw2x2ToggleColors( this, 'leave' );		
			});
		}
	});


});


function csw2x2ToggleColors(e, mode) 
{
	var el = jQuery(e);
	var color = '';
	var nodes = ['.cswTitle', '.cswTitle a', '.cswSubtitle', '.cswLine', '.cswDesc'];
	
	var mainColor = getOverlayColor(el, '');
	if( mainColor === '' )
	{
		// remove on mouseevents
		return;
	}

	// loop over sub nodes
	jQuery.each( nodes, function(index, item) {
		// get sub element
		var subEl = el.parent().find('.cswInBlock ' + item);
			
		// set color
		if( mode === 'enter' )		
			subEl.css('color', mainColor );
		else						// use original color
			subEl.css('color', subEl.data('color') );
	});
}


function getOverlayColor(el, overlay)
{
	// get color from hoverOverlay
	if( overlay != '' )
	{
		var subEl = el.find( overlay );
		if( subEl === 'undefined' || typeof subEl === 'undefined' )
			return '';
	}
	else
		subEl = el;
	
	var attr = subEl.attr('style');
	var colorStyle = '';
	
	if( attr === 'undefined' || typeof attr === 'undefined')
		return '';
	else
	{
		var attrArray = attr.split();
	
		jQuery.each( attrArray, function(index,item) {
			if( item.indexOf( 'color:' ) == 0 )
				colorStyle = subEl.css('color');
		});
	}
	
	return colorStyle;
}


function setOrigColorInDataAttr( e )
{
	var el = jQuery(e);
	var color = '';
	var nodes = ['.cswTitle', '.cswTitle a', '.cswSubtitle', '.cswLine', '.cswDesc'];
	
	var mainColor = getOverlayColor(el, '');
	if( mainColor === '' )
		return false;
	
	jQuery.each( nodes, function(index, item){
		var subEl = el.parent().find('.cswInBlock ' + item);
		var d = subEl.data('color');
		
		if( d == 'undefined' || typeof d == 'undefined' )
		{
			// get current Color
			var orig = subEl.css('color');
			
			// set data attribute
			subEl.data('color', orig);
		}			
		else
			return true;
	});
	
	return true;
}