/*
	csw-videotextblock.js
   
	Version: [2018-01-18 16:45]
*/

/******************************************************/
/*********** Modal Video Player Functions *************/
/******************************************************/

function removePlayerFromModal(containerID) 
{
   var domID = 'vid_' + containerID;

   // Clear the Player Container
   jQuery('#'+domID).empty();
}

function updateVideoModalText(modalID,title,desc)
{
   // make sure we have a single leading pound sign on the modalID
   modalID = '#' + modalID.replace(/^#/, '');;

   jQuery(modalID + ' .modal-title').html(title);
   if ( typeof desc != 'undefined' && desc.length ) 
      jQuery(modalid + ' .cswVideoDesc').html(desc);
   
}

function removeVideoAndTextFromModalOnClose(modalID)
{
   // make sure we have a single leading pound sign on the modalID
   modalID = '#' + modalID.replace(/^#/, '');;
   
   // On close remove video iFrame and description form Modal Dialog  
   jQuery(modalID).on('hidden.bs.modal', function () {
   
      // Removes the video from the DOM to stop it from playing in the background after modal is closed
      jQuery(this).find('.cswVideoPlayer').empty();
      
      // Also remove the text from the modal title and video description
      jQuery(this).find('.modal-title').empty();
      jQuery(this).find('.cswVideoDesc').empty();
   });
}

/************************************************/
/*********** Render Video Functions *************/
/************************************************/

function renderYTVideo(containerID)
{
	var domID = 'vid_' + containerID;
	var pDiv = document.getElementById(domID);
	var aL = arguments.length;
	var alist = 'containerID,'+arguments[aL-1];
	var aArr = alist.split(',');
	var src = "https://www.youtube.com/embed/" + arguments[1] + "?enablejsapi=1";
   var protocol = ''
   var host = '';
   var skipList = 'protocol,host';
   //var width = '100%';
	//var height = 500;

//console.log('arguments:',arguments);
//console.log('aArr:',aArr);
   
   // Clear the Div before showing the video 
   pDiv.innerHTML = '';
   
   for (i=1; i<aArr.length; i++)
	{
		if (skipList.indexOf(aArr[i])<0)
      {
         if (aArr[i] == 'origin' && arguments[i] == 'cs_Site_Location')
         {
            var pIndex = aArr.indexOf('protocol');
            if (pIndex>=0)
               protocol = arguments[pIndex];
            var hIndex = aArr.indexOf('host');
            if (hIndex>=0)
               host = arguments[hIndex];
            
            if ( protocol.length && host.length )
               src += '&origin='+protocol+'//'+host;
   		}
         else if (aArr[i] == 'loop' )
         {
            src += '&' + aArr[i] + '=' + arguments[i];
            // Required for YT LOOP to work -  &playlist=VIDEO_ID
            if ( arguments[i] == 1 ) 
               src += '&playlist=' + arguments[1];
         }
         else 
   		   src += '&' + aArr[i] + '=' + arguments[i];
      }
	}
   
// To hard code AutoPlay & Loop  enabled   
//src += '&autoplay=1';
//src += '&loop=1&playlist=' + arguments[1];
//console.log('src:',src);
   
   var iFrameHTML = '<div style="position:relative;width:100%;height:0px;padding-bottom:60%;">';
   iFrameHTML = iFrameHTML + '<iframe id="ytPlayer'+containerID+'" class="cswVideoPlayerNoBorder" style="position:absolute;left:0px;top:0px;width:100%;height:100%;border:none;" border="0" src="' + src + '"></iframe>';
   iFrameHTML = iFrameHTML + '</div>';

   //var iFrameHTML = '<iframe id="ytPlayer'+containerID+'" width="100%" class="cswVideoPlayerNoBorder" border="0" src="' + src + '"></iframe>';
	//var iFrameHTML = '<iframe id="ytPlayer'+containerID+'" width="100%" height="500" class="cswVideoPlayerNoBorder" border="0" src="' + src + '"></iframe>';
	
   pDiv.innerHTML = iFrameHTML;
}

function renderBCVideo(containerID)
{
	var domID = 'vid_'+containerID;
	var pDiv = document.getElementById(domID);
	var aL = arguments.length;
	var alist = 'containerID,'+arguments[aL-1];
	var aArr = alist.split(',');
	var src = "//players.brightcove.net/";
	var dIndex = aArr.indexOf('publisherID');
   var booleanList = 'controls,muted,loop,autoplay'; 
   var skipList = 'videoID';
   //var width = '100%';
	//var height = 500;
   
   // Clear the Div before showing the video
   pDiv.innerHTML = '';
   
//console.log('arguments:',arguments);
//console.log('aArr:',aArr);
	
   if (dIndex>=0)
		src += arguments[dIndex];
	dIndex = aArr.indexOf('dataPlayer');
	if (dIndex>=0)
		src += '/' + arguments[dIndex] + '_default/index.html?videoId=';
	dIndex = aArr.indexOf('videoID');
	if (dIndex>=0)
		src += arguments[dIndex];
	
   for (i=1; i<aArr.length; i++)
	{
	   if (skipList.indexOf(aArr[i])<0)
      {
         if ( booleanList.indexOf(aArr[i])>=0 ) 
         { 
            if ( arguments[i] == 1 )
               src += '&' + aArr[i];
         }
         else
            src += '&' + aArr[i] + '=' + arguments[i];
      }
	}
   
   // To hard code AutoPlay & Loop  enabled
   //src += '&autoplay=1';
   //src += '&loop=1';
   //src += '&loop';
//console.log('src:',src);

   var iFrameHTML = '<div style="position:relative;width:100%;height:0px;padding-bottom:60%;">';
   iFrameHTML = iFrameHTML + '<iframe id="bcPlayer'+containerID+'" class="cswVideoPlayerNoBorder" style="position:absolute;left:0px;top:0px;width:100%;height:100%;border:none;" border="0" src="' + src + '"></iframe>';
   iFrameHTML = iFrameHTML + '</div>';
   
	//var iFrameHTML = '<iframe id="bcPlayer'+containerID+'" width="100%" class="cswVideoPlayerNoBorder" border="0" src="' + src + '"></iframe>';
   //var iFrameHTML = '<iframe id="bcPlayer'+containerID+'" width="100%" height="500" class="cswVideoPlayerNoBorder" border="0" src="' + src + '"></iframe>';
	
   pDiv.innerHTML = iFrameHTML;
}

function renderLocalVideo(containerID)
{
	var domID = 'vid_'+containerID;
	var iFrameHTML = '';
	var pDiv = document.getElementById(domID);
	var aL = arguments.length;
	var alist = 'containerID,'+arguments[aL-1];
	var aArr = alist.split(',');
	var params = {};
	var dIndex = '';
	var rArr = "clsid,height,mimetype,src,width,src_mp4_url,src_ogv_url,src_webm_url,autoplay,loop".split(',');
	var width = '100%';
	var height = 500;
	var clsid = '';
   var mimetype = '';
   var src_mp4 = '';
   var src_ogv = '';
   var src_webm = '';
	var skip = 'width,height';
   var videoProps = '';
   
   // Clear the Div before showing the video
   pDiv.innerHTML = '';
	
   for (var i=0; i<rArr.length; i++)
	{
		dIndex = aArr.indexOf(rArr[i]);
		if (dIndex>=0 && skip.indexOf(rArr[i])<0)
		{
			params[rArr[i]] = arguments[dIndex];
			if (rArr[i] == 'clsid')
				clsid = arguments[dIndex];
			if (rArr[i] == 'mimetype')
				mimetype = arguments[dIndex];
			if (rArr[i] == 'src_mp4_url')
				src_mp4 = arguments[dIndex];
			if (rArr[i] == 'src_ogv_url')
				src_ogv = arguments[dIndex];
			if (rArr[i] == 'src_webm_url')
				src_webm = arguments[dIndex];
      }		
	}

   // To hard code AutoPlay & Loop  enabled
   //params['autoplay'] = true;
   //params['loop'] = true;
   
//console.log('params',params); 
  
   if (clsid != '' && typeof clsid != 'undefined')
	   CreateAndActivateControl('vid_'+containerID,'cpHideForMenus',clsid,width,height,'',params,'');
   else
	{
      if (height != '')
		{
			height = escape(height);
         if ( height.indexOf('%25') < 0)
				height = height +'px';
		}
      
      // check for autoplay &  loop 
      if ( params.hasOwnProperty('autoplay') && params['autoplay'] == 1  )
         videoProps += ' autoplay';
      if ( params.hasOwnProperty('loop') && params['loop'] == 1 )
         videoProps += ' loop';
      
		vHTML = '<video width="' + width + ' height="' + height + '" controls '+videoProps+' preload="auto" poster="">';
      if (src_mp4 != '')
			vHTML += '<source src="' + src_mp4 + '" type="video/mp4">';
		if (src_ogv != '')
			vHTML += '<source src="' + src_ogv + '" type="video/ogg">';
		if (src_webm != '')
			vHTML += '<source src="' + src_webm + '" type="video/webm">';
	
		vHTML += 'Your browser does not support the video tag.</video>';	
		pDiv.innerHTML = vHTML;
	}	
}

/**************************************************/
/*********** Player On Page Functions *************/
/**************************************************/

function clearPlayerOnPageContainer(containerID) 
{
   var domID = 'vid_' + containerID;

   // Clear the Player Container
   //jQuery('#'+domID).empty().removeClass('cswLoadingComplete');
}

function hidePlayerOnPagePlaceHolder(containerID) 
{
   var domID = 'vid_' + containerID;

   jQuery('#'+domID).removeClass('cswLoadingComplete')
                     .addClass('cswLoading');
                       
   setTimeout(function () {  
      jQuery('#'+domID).removeClass('cswLoading')
                        .addClass('cswLoadingComplete')
                        .css({'border':'none'});
   }, 1500);

}

function setPlayerOnPageContainerHeight(containerID,percentWidth) 
{
   percentWidth = typeof percentWidth !== 'undefined' ? percentWidth : '100%';
   
   var domID = 'vid_' + containerID;
   var $playerEl = jQuery('#'+domID);
   var playerWidth = $playerEl.width(); 
	var playerHeight = 0;
   
   if ( !$playerEl.is(":visible") ) 
      playerWidth = $playerEl.actual( 'width' ); 
   
   playerHeight = getPlayerHeight('widescreen',playerWidth);
  	
   jQuery('#'+domID).css({width: percentWidth,height: playerHeight+'px'});
}


function getPlayerHeight(aspectRatio,vWidth) {
	var vHeight, vSizeStr;
	if ( aspectRatio == 'widescreen' ) 
		vHeight = getHeight(vWidth,16,9);
	else 
		vHeight = getHeight(vWidth,4,3);
	
	return vHeight;
}
function getHeight(newWidth,orginalWidth,originalHeight) {
	if (orginalWidth == 0)
		return newWidth;
	var aspectRatio = orginalWidth / originalHeight;
	return Math.round(newWidth / aspectRatio);
}
function getWidth(newHeight,orginalWidth,originalHeight) {
	if(originalHeight == 0)
      return newHeight;
	var aspectRatio = orginalWidth / originalHeight;
	return Math.round(newHeight * aspectRatio);
} 
function parseAspectRatioStyle(vWidth,vHeight) {
	var aspectRatioStr = 'standard';
	var aspectRatio = (vWidth / vHeight);
	var arWide = aspectRatio * 9;
	var arStandard = aspectRatio * 3;
	
   if ( arWide == 16 ) 
		aspectRatioStr = 'widescreen';
	else if ( arStandard == 4 ) 
		aspectRatioStr = 'standard';

	return aspectRatioStr;
}

function setPlayerOnPageFixedPosition(playerID,listingContainerID,playerFixedTop,disableFixedBreakpoint) 
{
	playerFixedTop = typeof playerFixedTop !== 'undefined' ? playerFixedTop : 0;
   disableFixedBreakpoint = typeof disableFixedBreakpoint !== 'undefined' ? disableFixedBreakpoint : 480;
   
   var $playerEl = jQuery('#'+playerID);
	var fixedTop = playerFixedTop;
	var initalTop = $playerEl.offset().top;  // get initial position of the element
   var playerWidth = $playerEl.actual( 'width' ); 
	var playerHeight = $playerEl.actual( 'height' );
   var playerOuterHeight = $playerEl.actual( 'outerHeight', { includeMargin : true });

   // Disble the Fixed Postion Handler if below the Breakpoint value
   if ( jQuery(window).width() > disableFixedBreakpoint )
   {		
   	
      // Create the Custom Scroll Handler Function
      var scrollHandler = function(){
      
          currentScroll = jQuery(window).scrollTop();
						 
   		 // check for the icon first loaded class
   		 if (  $playerEl.hasClass('cswIconFirstLoad') )
   		 		$playerEl.removeClass('cswIconFirstLoad');
						 
   	    if ( currentScroll >= fixedTop ) 
   		 {
   		 		var fixedTopOffset = fixedTop - 80;
            
               // Must update on the fly in-case hidden when loaded
               var listDivStopPos = getListingStopPosition(listingContainerID,playerOuterHeight,fixedTop);
								
   				// Don't let it go past the length of the video list
   				if ( currentScroll > listDivStopPos && listDivStopPos > 0 )
   		 		{

   					var maxTopStop = listDivStopPos - fixedTop;
									
   					$playerEl.css({               
   						position: 'relative',
   						top: maxTopStop,
   						width: playerWidth
   				  });
   				}
   				else
   				{
									
   					$playerEl.css({               
   						position: 'fixed',
   						top: fixedTopOffset,
   						width: playerWidth
   				  });
								  
   			  }
   		 }
   		 else 
   		 {   

              $playerEl.css({                 		
   	            position: 'relative',
   					top: 0,
   					width: playerWidth
   	        });
   	    }
      }

      // Call the Custom Scroll handler for the fixed position player
      jQuery(window).scroll(scrollHandler);
	}
   else
   {
      
      // Disable the custom scroll handler
      jQuery(window).off("scroll", scrollHandler);
   
      // Get the current width, height and top 
      playerWidth = $playerEl.actual( 'width' );
      playerHeight = $playerEl.actual( 'height' );
      playerTop = $playerEl.css( 'top' );
      
      // Lock the position of the player for mobile
      $playerEl.css({                 		
         position: 'static',
			top: playerTop,
			width: playerWidth,
         height: playerHeight,
         'margin-top': '30px',
         'margin-right': 'auto',
         'margin-bottom': '30px',
         'margin-left': 'auto'
     });
   }					
}

function getListingStopPosition(listingContainerID,playerOuterHeight,playerFixedTop) {
   var stopPos = jQuery(document).height();
   
   if ( jQuery('#'+listingContainerID).length && jQuery('#'+listingContainerID).is(":visible") )
	{
	 	var $listingEl = jQuery('#'+listingContainerID);
      
      var aPosTop = $listingEl.position().top;
      var aOffsetTop = $listingEl.offset().top;
      var aHeight = $listingEl.actual( 'outerHeight', { includeMargin : true } );
		
      stopPos = aPosTop + aOffsetTop + aHeight - playerOuterHeight - playerFixedTop;
   }
   
   return stopPos;
}